import java.util.*;
import platoto.*;

public class Jeu {
    private Plateau<Pion> plateau;
    private Joueurs joueurs;
    private Joueur gagnant;
    private HashSet<ObservateurDePlateau> observateurs;
    public Jeu(Joueurs lesJoueurs) {
	joueurs = lesJoueurs;
	plateau = new PlateauReactif(nombreDeJoueurs (),10);
	observateurs = new HashSet<> ();
	Iterator<Joueur> j = joueurs.iterator();
	while (j.hasNext()) {
	    j.next().poseSonPion(plateau);
	}
	gagnant = null;
    }

    public void enregistre (ObservateurDePlateau p) {
	observateurs.add (p);
    }

  public int nombreDeJoueurs() {
    return joueurs.nombre();
  }
  public void add(Joueur j) {
    joueurs.add(j);
    j.poseSonPion(plateau);
  }

    public void notifie () {
	for (ObservateurDePlateau p : observateurs) {
	    p.observe (plateau);
	}
    }
    
    
  public void deroule() {
      notifie ();
    while (!termine()) {
      Joueur celuiQuiJoue = joueurs.suivant();
      celuiQuiJoue.joue();
      notifie ();
      if (celuiQuiJoue.aGagne()) {
        gagnant = celuiQuiJoue;
      }
    }
  }
  public boolean termine() {
    return gagnant!=null;
  }
  public Joueur gagnant() {
    return gagnant;
  }
}
