package platoto;

import java.util.*;

public class Plateau <P> {
  public class Case {
    private int index;
    private Set<P> pions;
    public Case(int i) {
      index = i;
      pions = new HashSet<P>();
    }
    public Iterator<P> iterator() {
      return pions.iterator();
    }
    public void add(P p) {
      pions.add(p);
    }
    public void remove(P p) {
      pions.remove(p);
    }
    public boolean derniere() {
      return Plateau.this.cases.length-1==index;
    }
    public Case suivante(Mouvement m) {
      return Plateau.this.suivante(this,m);
    }
  } // fin classe Case
  private Case[] cases;
  private int largeur_case;
  public Plateau(int l,int n) {
      cases = new Case[n];
    for (int i=0; i<n; i++) cases[i] = new Case(i);
    largeur_case = l;
  }
  private Case suivante(Case c,Mouvement m) {
    if (m.direction()==Mouvement.AVANT) {
      if (c.index<cases.length-1)
        return cases[c.index+1];
      else {
        m.inverse();
        return suivante(c,m);
      }
    }
    else {
      if (c.index>0)
        return cases[c.index-1];
      else
        return cases[c.index];
    }
  }
  public void add(P p) {
      cases[0].add (p);
  }
  public Case premiereCase() {
    return cases[0];
  }
  public Case derniereCase() {
    return cases[cases.length-1];
  }
  public String toString() {
    String s = "";
    for (int i=0; i<cases.length; i++) {
      int idx=0;
      Iterator<P> it = cases[i].iterator();
      while (it.hasNext()) {
        s += it.next().toString();
        idx++;
      }
      for (; idx < largeur_case; idx++) s += ' ';
      s += '|';
    }
    return s;
  }
}
